﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Tabelle2
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            panel2.Dock = DockStyle.Fill;
            Grid1.Dock = DockStyle.Fill;
            setGUI();
        }

        private void setGUI()
        {
            Grid1.RowCount = 1;
            Grid1.ColumnCount = 5;  // einen weniger, da dynamisch addiert !!
            Grid1.Columns[0].Name = "MitarbeiterNr";
            Grid1.Columns[1].Name = "Name";
            Grid1.Columns[2].Name = "Vorname";
            Grid1.Columns[3].Name = "Abteilung";
            Grid1.Columns[4].Name = "Gehalt";

            int width1 = Grid1.Width - 70;  // Rand und erste Spalte
            int w = width1 / Grid1.ColumnCount;
            for (int i = 0; i < Grid1.ColumnCount; i++)
            {
                Grid1.Columns[i].Width = w;
            }


            Grid1.SelectionMode = DataGridViewSelectionMode.CellSelect;
            //Grid1.SelectionMode = DataGridViewSelectionMode.ColumnHeaderSelect;
            //Grid1.SelectionMode = DataGridViewSelectionMode.FullColumnSelect;
            Grid1.SelectionMode = DataGridViewSelectionMode.FullRowSelect;
            Grid1.SelectionMode = DataGridViewSelectionMode.RowHeaderSelect;

            Grid1.SelectionMode = DataGridViewSelectionMode.CellSelect;

            Grid1.MultiSelect = true;


            object[] row0 = { "1", "Meier", "Andreas", "Finanzen", "1.203" };
            object[] row1 = { "2", "Schmidt", "Ralf", "Marketing", "5.104"};
            object[] row2 = { "3", "Bender", "Hans", "CEO", "11.001"};
            object[] row3 = { "4", "Opel", "Hans-Dieter", "Informatic", "3.455"};
            object[] row4 = { "66", "Bischoff", "Hugo", "Forschung", "5.434" };
            object[] row5 = { "77", "Ernst", "Uwe", "Controlling", "7.656" };
            object[] row6 = { "78", "Schulze", "Sabine", "Controlling", "7.655" };

            Grid1.Rows.Add(row0);
            Grid1.Rows.Add(row1);
            Grid1.Rows.Add(row2);
            Grid1.Rows.Add(row3);
            Grid1.Rows.Add(row4);
            Grid1.Rows.Add(row5);
            Grid1.Rows.Add(row6);

            Grid1.ReadOnly = false;

            Grid1.AutoSize = true;

        }  // setGUI

        // Export in die Zwischenablage, Trennung mittels tab
        // ideal für Excel etc.
        // es fehlt noch die Konvertierung Programmierung Punkt to Excel Komma
        private void BnExport_Click(object sender, EventArgs e)
        {
            string sExport = "";
            string sStr;
            
            // Ablauf mit Zeilen und Spalten, geht von unten nach oben
            for (int col = 0; col < Grid1.ColumnCount; col++)
            {
                sStr = Grid1.Columns[col].HeaderText;
                if (col==0)
                    sExport = sStr;
                else
                    sExport = sExport + "\t" + sStr;
            }            
            for (int row=0; row<Grid1.RowCount; row++)
            {
                for (int col=0; col<Grid1.ColumnCount; col++)
                {
                    if (Grid1.Rows[row].Cells[col].Value != null)
                    {
                        sStr = Grid1.Rows[row].Cells[col].Value.ToString();
                        if ( col == 0 )
                            sExport = sExport + "\r\n" + sStr;
                        else
                            sExport = sExport + "\t" + sStr;

                    }
                }
            }
            Clipboard.SetText(sExport);
            //Oder
            /*
            ClipboardTextbox.Text = sExport;
            ClipboardTextbox.Visible = true;
            ClipboardTextbox.SelectAll();
            ClipboardTextbox.Copy();
             */
        }  // BnExport


        private void BnExport2_Click(object sender, EventArgs e)
        {
            string sExport = "";
            //int row = -1;
            // Ablauf mit Zeilen und Spalten, geht von unten nach oben
            for (int i = (Grid1.SelectedCells.Count - 1); i >= 0; i--)
            {
                int col2 = Grid1.SelectedCells[i].ColumnIndex;
                int row2 = Grid1.SelectedCells[i].RowIndex;
                sExport = sExport + "\r\n" + col2.ToString() + "/" + row2.ToString();

                //if (sExport.Equals(""))
                //{
                //    sExport = Grid1.SelectedCells[i].FormattedValue.ToString();
                //    row=Grid1.SelectedCells[i].RowIndex;                
                //}
                //else
                //{
                //    if (Grid1.SelectedCells[i].RowIndex!=row)
                //        sExport = sExport + "\r\n" + Grid1.SelectedCells[i].FormattedValue.ToString();//neue Zeile
                //    else
                //        sExport = sExport + "\t" + Grid1.SelectedCells[i].FormattedValue.ToString();
                //    row=Grid1.SelectedCells[i].RowIndex;                
                //}
            }
            ClipboardTextbox.Text = sExport;
            ClipboardTextbox.Visible = true;
            ClipboardTextbox.SelectAll();
            ClipboardTextbox.Copy();
        }

        private void BnNew_Click(object sender, EventArgs e)
        {
            object[] row = { "223", "Winder", "Ute", "Programmierung", "3.455" };

            Grid1.Rows.Add(row);

        }  // BnExport2

    }



}

/*
private void Menu_Copy(System.Object sender, System.EventArgs e)
 {
    // Ensure that text is selected in the text box.   
    if(textBox1.SelectionLength > 0)
        // Copy the selected text to the Clipboard.
        textBox1.Copy();
 }

 private void Menu_Cut(System.Object sender, System.EventArgs e)
 {   
     // Ensure that text is currently selected in the text box.   
     if(textBox1.SelectedText != "")
        // Cut the selected text in the control and paste it into the Clipboard.
        textBox1.Cut();
 }

 private void Menu_Paste(System.Object sender, System.EventArgs e)
 {
    // Determine if there is any text in the Clipboard to paste into the text box.
    if(Clipboard.GetDataObject().GetDataPresent(DataFormats.Text) == true)
    {
        // Determine if any text is selected in the text box.
        if(textBox1.SelectionLength > 0)
        {
          // Ask user if they want to paste over currently selected text.
          if(MessageBox.Show("Do you want to paste over current selection?", "Cut Example", MessageBoxButtons.YesNo) == DialogResult.No)
             // Move selection to the point after the current selection and paste.
             textBox1.SelectionStart = textBox1.SelectionStart + textBox1.SelectionLength;
        }
        // Paste current text in Clipboard into text box.
        textBox1.Paste();
    }
 }


 private void Menu_Undo(System.Object sender, System.EventArgs e)
 {
    // Determine if last operation can be undone in text box.   
    if(textBox1.CanUndo == true)
    {
       // Undo the last operation.
       textBox1.Undo();
       // Clear the undo buffer to prevent last action from being redone.
       textBox1.ClearUndo();
    }
 }

*/